
#include <stdio.h>
#include <stdlib.h>
#include "../qKernel.h"

uint32_t volatile dat;
void Thread1(void* Dummy) {
    while (1) {
        //Toggle LED
        qThrSleep(300000);
    }
}

void Thread2(void* Dummy) {
    while (1) {
        //Toggle LED);
        qThrSleep(100000);
    }
}

unsigned qErrNotify(unsigned Error) {
    if (Error==0) {
        return 0;
    }
    qKrnError(Error);       // This will reset the system
    return Error;
}


int main(int argc, char** argv) {
    //CLKDIVbits.RCDIV = 0;                       // Speed up MCU to 16MIPS
    pERR err = qKrnInit(16000000, 128, 256, 4);
                                                // Freq = 16000000Hz
                                                // IdleThreadStack = 64 bytes
                                                // InterruptStack = 200 bytes
                                                // FiberQueueSize = 4 entries
    if (err) {
        qBREAKPOINT;                             // Stop in debug mode. Look into err
        Nop();
        Nop();
        Nop();
    }
    qThrCreate("Thread2", Thread2, 0, 256, 120);
    qThrCreate("Thread1", Thread1, 0, 256, 110);// Thread 1 has lowest priority (110)
    qKrnStart();                                // Start the kernel
    return 0;                                   // We should never get here
}

