
#include <stdio.h>
#include <stdlib.h>
#include "../qKernel.h"


void Thread1(void* Dummy) {
    int volatile x = 0;
    while (1) {
        //Toggle the Led
        qThrSleep(300000);
    }
}

void Thread2(void* Dummy) {
    int volatile x = 0;
    while (1) {
        //Toggle anothe LED;
        qThrSleep(100000);
    }
}

unsigned qErrNotify(unsigned Error) {
    if (Error==0) {
        return 0;
    }
    qBREAKPOINT;
    //qKrnError(Error);       // This will reset the system
    return Error;
}
#include <plib.h>
#pragma config FPLLMUL = MUL_20, FPLLIDIV = DIV_2, FPLLODIV = DIV_1, FWDTEN = OFF
#pragma config POSCMOD = HS, FNOSC = PRIPLL, FPBDIV = DIV_1


int main(int argc, char** argv) {
	unsigned int cache_status;
	mCheConfigure(2);
    cache_status = mCheGetCon();
    cache_status |= CHE_CONF_PF_ALL;
    mCheConfigure(cache_status);
	INTEnableSystemMultiVectoredInt();		// enable multi-vectore interrupts
	SYSTEMConfig(80000000, SYS_CFG_WAIT_STATES | SYS_CFG_PCACHE);
	RCON = 0;
	mJTAGPortEnable(0);



    pERR err = qKrnInit(80000000, 256, 256, 4);
                                                // Freq = 80000000Hz
                                                // IdleThreadStack = 256 bytes
                                                // InterruptStack = 256 bytes
                                                // FiberQueueSize = 4 entries
    if (err) {
        qBREAKPOINT;                             // Stop in debug mode. Look into err
        Nop();
        Nop();
        Nop();
    }
    err = NULL;
    
    
    qThrCreate("Thread2", Thread2, 0, 256, 120);
    qThrCreate("Thread1", Thread1, 0, 256, 110);// Thread 1 has lowest priority (110)
    qKrnStart();                                // Start the kernel
    return 0;                                   // We should never get here
}

// declared static in case exception condition would prevent
// auto variable being created
static enum {
	EXCEP_IRQ = 0,			// interrupt
	EXCEP_AdEL = 4,			// address error exception (load or ifetch)
	EXCEP_AdES,				// address error exception (store)
	EXCEP_IBE,				// bus error (ifetch)
	EXCEP_DBE,				// bus error (load/store)
	EXCEP_Sys,				// syscall
	EXCEP_Bp,				// breakpoint
	EXCEP_RI,				// reserved instruction
	EXCEP_CpU,				// coprocessor unusable
	EXCEP_Overflow,			// arithmetic overflow
	EXCEP_Trap,				// trap (possible divide by zero)
	EXCEP_IS1 = 16,			// implementation specfic 1
	EXCEP_CEU,				// CorExtend Unuseable
	EXCEP_C2E				// coprocessor 2
} _excep_code;

static unsigned int _epc_code;
static unsigned int _excep_addr;

// this function overrides the normal _weak_ generic handler
void _general_exception_handler()
{
    if (_TIMER_4_VECTOR)
    asm volatile("mfc0 %0,$13" : "=r" (_excep_code));
	asm volatile("mfc0 %0,$14" : "=r" (_excep_addr));

	_excep_code = (_excep_code & 0x0000007C) >> 2;

	while (1) {
		// Examine _excep_code to identify the type of exception
		// Examine _excep_addr to find the address that caused the exception
	}
}
