/*************************************************************************************
 **  Q-KernelFree  Copyright (C) 2013 QuasarSoft Ltd.                               **
 **                                                                                 **
 **  This file is part of Q-KernelFree distribution.                                **
 **  Q-KernelFree is free software:  you can redistribute it and/or modify it under **
 **  the terms of the  GNU  General  Public  License  (version 3) as published  by  **
 **  the Free Software  Foundation ***** AND MODIFIED BY ***** the QuasarSoft Ltd.  **
 **  exception.                                                                     **
 **                                                                                 **
 **    *********************** The QuasarSoft Ltd. EXCEPTION ******************     **
 **    * You may not exercise any of the rights granted to You in any manner  *     **
 **    * that is primarily intended for or directed toward commercial         *     **
 **    * advantage or private monetary compensation. The exchange of the      *     **
 **    * Program for other copyrighted works by means of digital file-sharing *     **
 **    * or otherwise shall not be considered to be intended for or directed  *     **
 **    * toward commercial advantage or private monetary compensation,        *     **
 **    * provided there is no payment of any monetary compensation in         *     **
 **    * connection with the exchange of copyrighted works.                   *     **
 **    ************************************************************************     **
 **                                                                                 **
 **  Q-KernelFree is distributed in the hope that it will be useful,  but  WITHOUT  **
 **  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS  ** 
 **  FOR  A  PARTICULAR  PURPOSE.  See the full license text at the following link  ** 
 **  <http://www.quasarsoft.com/license.html>                                       ** 
 **                                                                                 **
 *************************************************************************************/  

#include "qKernel.h"


pEVT qEvtCreate(char* pName) {
    pEVT p;

#ifndef __NO_CHECK__
    if (qKrnInIsr()) {
        xErrNtf(qERR_EVT_ISR);
        return NULL;
    }
    if (xErrNtf(xObjCheck(pName, qERR_EVT_ID, xTYPE_EVT))) {
        return NULL;
    }
#endif 
    qCrtEnter();
    p = xObjAlloc(xTYPE_EVT,0);
    if (!p) {
        xErrNtf(qERR_EVT_MEMORY);
        return NULL;
    }

    p->Type = xTYPE_EVT;
    p->pName = pName;
    qCrtExit();
    xObjRemOpenList(pName, xTYPE_OPN_EVT);   // Make waiting Open threads runnable
    return p;    
}


