/*************************************************************************************
 **  Q-KernelFree  Copyright (C) 2013 QuasarSoft Ltd.                               **
 **                                                                                 **
 **  This file is part of Q-KernelFree distribution.                                **
 **  Q-KernelFree is free software:  you can redistribute it and/or modify it under **
 **  the terms of the  GNU  General  Public  License  (version 3) as published  by  **
 **  the Free Software  Foundation ***** AND MODIFIED BY ***** the QuasarSoft Ltd.  **
 **  exception.                                                                     **
 **                                                                                 **
 **    *********************** The QuasarSoft Ltd. EXCEPTION ******************     **
 **    * You may not exercise any of the rights granted to You in any manner  *     **
 **    * that is primarily intended for or directed toward commercial         *     **
 **    * advantage or private monetary compensation. The exchange of the      *     **
 **    * Program for other copyrighted works by means of digital file-sharing *     **
 **    * or otherwise shall not be considered to be intended for or directed  *     **
 **    * toward commercial advantage or private monetary compensation,        *     **
 **    * provided there is no payment of any monetary compensation in         *     **
 **    * connection with the exchange of copyrighted works.                   *     **
 **    ************************************************************************     **
 **                                                                                 **
 **  Q-KernelFree is distributed in the hope that it will be useful,  but  WITHOUT  **
 **  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS  ** 
 **  FOR  A  PARTICULAR  PURPOSE.  See the full license text at the following link  ** 
 **  <http://www.quasarsoft.com/license.html>                                       ** 
 **                                                                                 **
 *************************************************************************************/  

#include "qKernel.h"

const VER qcVer = {xVER_MAJOR,xVER_MINOR,xVER_BUILD};

uint64_t qvLostCycles qNEAR = 0;                // Cycles lost due to closed threads
uint32_t qvTotalTMR qNEAR = 0;                  // Running timer value used in yTimer
uint64_t qvCycles qNEAR = 0;                    // Number of cycles used by system yTimer
                                                            
pTCB qvCurTcb qNEAR = 0;                        // TCB of current thread
pTCB qvRdyList qNEAR = 0;                       // Ready list
pTCB qvTimerList qNEAR = 0;                     // Thread/Timer Timer list
pTCB qvRtccList qNEAR = 0;                      // Thread/Timer RTCC list
pOBJ qvObjectList qNEAR = 0;                    // List of all non-thread objects
pMSG qvMsgList qNEAR = 0;                       // List of messages in memory (non-mixed memory)
pTCB qvIdleTcb qNEAR = 0;                       // Pointer to the idle TCB
                                                            
                                                            
unsigned* qvIntStackLimit qNEAR = 0;            // Pointer to the limit of the stack
unsigned* qvIntStack qNEAR = 0;                 // Pointer to interrupt stack
                                                            
void (*qvSpawnFun[4])(void) qNEAR = {0,0,0,0};  // Spawn functions
unsigned qvSpawn qNEAR = 0;                     // spawn call indicators
                                                // bit0 = Priority fiber 4
                                                // bit1 = Priority fiber 3
                                                // bit2 = Priority fiber 2
                                                // bit3 = Priority fiber 1
                                                // bit4 = reserved
                                                // bit5 = xFbrTimerExpire    Kernel-Timer expired
                                                // bit6 = Reserved
                                                // bit7 = xFbrRTCCExpire     RTCC expired 
                                                // bit8 fiber queue (Does not contain an address)
                                                // bit9 to bit14 reserved
                                                            
unsigned* qvFbrPut qNEAR = 0;                   // Write fibers here
unsigned* qvFbrGet qNEAR = 0;                   // Read fibers here
unsigned* qvFbrTrackAdr qNEAR = 0;              // Address of bit to set/clr for fiber tracking
unsigned qvFbrTrackBit qNEAR = 0;               // Bit to set/clr for fiber tracking
                                                            
unsigned qvKernel qNEAR = 0;                    // All bits to indicates state of the OS
int qvInCritical qNEAR = 0;                     // -1=NoCritical 0=FirstCritical 1=Next etc
                                                            
pMPL qvMemObjPool qNEAR = 0;                    // Pool for all Objects
pMPL qvMemTcbPool qNEAR = 0;                    // Pool for all TCBs
pMPL qvMemTmrPool qNEAR = 0;                    // Pool for all Timers
pMPL qvMemPoolList qNEAR = 0;                   // Mem pool list header
pFPL qvFixPoolList qNEAR = 0;                   // Fix pool list header
unsigned* qvMemHeap qNEAR = 0;                  // Heap list header
void* qvSpawnRtccExpire qNEAR = 0;              // Contains function xFbrRTCCExpire 
uint8_t* qvTrackingSleepAdr qNEAR = 0;          // Address of the tracking bit for sleep
uint8_t* qvTrackingIdleAdr qNEAR = 0;           // Address of the tracking bit for idle
uint8_t* qvTrackingRunAdr qNEAR = 0;            // Address of the tracking bit for run

int volatile qvInIdlePreventMode qNEAR = 0;     // 0=Idle allowed 1->n Idle prevented
int volatile qvInSleepPreventMode qNEAR = 0;    // 0=Sleep allowed 1->n Sleep prevented

uint32_t qvClockFrequency qNEAR = 0;
uint16_t qvClockFrequencyDiv15625 qNEAR = 0;
uint16_t qvClockFrequencyMul256Div1000000 qNEAR = 0;
uint16_t qvClockFrequencyDiv1000000 qNEAR = 0;
uint16_t qvInterruptStackSize qNEAR = 0;

uint8_t qvTrackingSleepBit qNEAR = 0;           // Sleep Tracking bit to set or clear
uint8_t qvTrackingIdleBit qNEAR = 0;            // Idle Tracking bit to set or clear
uint8_t qvTrackingRunBit qNEAR = 0;             // Run Tracking bit to set or clear

uint8_t qvClockFrequencyMhzPower2 qNEAR = 0;
uint8_t qvRtcc qNEAR = 0;                       // Type of RTCC (0=None, 1=emulated, 2=TMR1, 3=HwRtcc)
uint8_t qvTimer qNEAR = 0;                      // Timer number (2=TMR2/TMR3 4=TMR4/TMR5, 6=TMR6/TMR7, 8=TMR8/TMR9)
uint8_t qvClockFrequencyMultiplyOf1000000 qNEAR = 0; // 1 then multiply of MHz

struct sERR qvErr __attribute__ ((persistent)) qNEAR ;



char qvIdleTcbName[] = "Idle";                              

pERR qKrnInit(uint32_t ClockFrequency, unsigned IdleThreadStackSize, unsigned InterruptStackSize, unsigned FiberQueueSize) {
    unsigned fbrSize;
    unsigned heapInitialSize;
    uint16_t remainder;
    int n;

    qvClockFrequency = ClockFrequency;
    qvInterruptStackSize = InterruptStackSize;
    qvClockFrequencyMul256Div1000000 = qDivU3216(qvClockFrequency*4,15625);
    qvClockFrequencyDiv1000000 = qDivU3216(qvClockFrequency>>6,15625);
    uint32_t tmp = qMulU3216(1000000UL, qvClockFrequencyDiv1000000);
    if (tmp==qvClockFrequency) {
        qvClockFrequencyMultiplyOf1000000 = 1;
    }
    // Ignore the warning "Taking the address of 'remainder' may require an extended pointer for this device
    // Q-Kernel never allocates the stack in memory above 0x8000
    qvClockFrequencyDiv15625 = qDivU3216R(qvClockFrequency,15625,&remainder);

    if (!(qvClockFrequencyDiv15625&0x3f || remainder)) { // To speed up qGetUSec()
        if (qvClockFrequencyDiv1000000==2) qvClockFrequencyMhzPower2 = 1;
        if (qvClockFrequencyDiv1000000==4) qvClockFrequencyMhzPower2 = 2;
        if (qvClockFrequencyDiv1000000==8) qvClockFrequencyMhzPower2 = 3;
        if (qvClockFrequencyDiv1000000==16) qvClockFrequencyMhzPower2 = 4;
        if (qvClockFrequencyDiv1000000==32) qvClockFrequencyMhzPower2 = 5;
        if (qvClockFrequencyDiv1000000==64) qvClockFrequencyMhzPower2 = 6;
        if (qvClockFrequencyDiv1000000==128) qvClockFrequencyMhzPower2 = 7;
        if (qvClockFrequencyDiv1000000==256) qvClockFrequencyMhzPower2 = 8;
    }
    heapInitialSize = yMemSetup(InterruptStackSize);// This will setup all memory and returns the heapsize

    #ifndef __NO_CHECK__
        if (heapInitialSize < 800) {
            xErrNtf(qERR_KRN_MEM_SIZE);
            return &qvErr; 
        }
    #endif

    fbrSize = FiberQueueSize*(sizeof(unsigned)*4);
    qvFbrGet = qHeaAlloc(fbrSize);
    qWrdClr((unsigned*)qvFbrGet,fbrSize);
    qvFbrPut = qvFbrGet;
    for (n=0; n<FiberQueueSize-1; n++) {        // Do all entries except the last one
        *qvFbrPut = (unsigned)(qvFbrPut+4);
        qvFbrPut+=4;
    }    
    *qvFbrPut = (unsigned)qvFbrGet;             // Last item pointers back to first
    qvFbrPut = qvFbrGet;

    qvMemObjPool = xMemInsPool(sizeof(struct sOBJ));
    qvMemTmrPool = xMemInsPool(sizeof(struct sTMR));
    qvMemTcbPool = xMemInsPool(sizeof(struct sTCB));
    
    qvIdleTcb = qThrCreate(qvIdleTcbName, xIdleThr, NULL, IdleThreadStackSize, 0);
    xKrnSetPriorityCheckOn();
    xKrnSetInitDone();                          // Init Done
    pERR err = yErrorInit();
    if (err != NULL) {
        return err;
    }

    qvTrackingSleepAdr = &qvTrackingSleepBit;   // Tracking address must be valid Bit is 0 so
    qvTrackingIdleAdr = &qvTrackingIdleBit;     // nothing happens.
    qvTrackingRunAdr = &qvTrackingRunBit;
    return NULL;
}
