/*************************************************************************************
 **  Q-KernelFree  Copyright (C) 2013 QuasarSoft Ltd.                               **
 **                                                                                 **
 **  This file is part of Q-KernelFree distribution.                                **
 **  Q-KernelFree is free software:  you can redistribute it and/or modify it under **
 **  the terms of the  GNU  General  Public  License  (version 3) as published  by  **
 **  the Free Software  Foundation ***** AND MODIFIED BY ***** the QuasarSoft Ltd.  **
 **  exception.                                                                     **
 **                                                                                 **
 **    *********************** The QuasarSoft Ltd. EXCEPTION ******************     **
 **    * You may not exercise any of the rights granted to You in any manner  *     **
 **    * that is primarily intended for or directed toward commercial         *     **
 **    * advantage or private monetary compensation. The exchange of the      *     **
 **    * Program for other copyrighted works by means of digital file-sharing *     **
 **    * or otherwise shall not be considered to be intended for or directed  *     **
 **    * toward commercial advantage or private monetary compensation,        *     **
 **    * provided there is no payment of any monetary compensation in         *     **
 **    * connection with the exchange of copyrighted works.                   *     **
 **    ************************************************************************     **
 **                                                                                 **
 **  Q-KernelFree is distributed in the hope that it will be useful,  but  WITHOUT  **
 **  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS  ** 
 **  FOR  A  PARTICULAR  PURPOSE.  See the full license text at the following link  ** 
 **  <http://www.quasarsoft.com/license.html>                                       ** 
 **                                                                                 **
 *************************************************************************************/  

#include "qKernel.h"


pSEM qSemCreate(char* pName, unsigned Permits) {
    pSEM p;

#ifndef __NO_CHECK__
    if (qKrnInIsr()) {
        xErrNtf(qERR_SEM_ISR);
        return NULL;
    }
    if (xErrNtf(xObjCheck(pName, qERR_SEM_ID, xTYPE_SEM))) {
        return NULL;
    }
#endif

    p = xObjAlloc(xTYPE_SEM,0);
    if (!p) {
        xErrNtf(qERR_SEM_MEMORY);
        return NULL;
    }

    qCrtEnter();
    p->Type = xTYPE_SEM;
    p->pName = pName;
    p->Permits = Permits;
    qCrtExit();
    xObjRemOpenList(pName, xTYPE_OPN_SEM);   // Make waiting Open threads runnable
    //
    // We return a pointer to the permits so some assembler code can be optimized 
    return (pSEM)&p->Permits;    
}
