/*************************************************************************************
 **  Q-KernelFree  Copyright (C) 2013 QuasarSoft Ltd.                               **
 **                                                                                 **
 **  This file is part of Q-KernelFree distribution.                                **
 **  Q-KernelFree is free software:  you can redistribute it and/or modify it under **
 **  the terms of the  GNU  General  Public  License  (version 3) as published  by  **
 **  the Free Software  Foundation ***** AND MODIFIED BY ***** the QuasarSoft Ltd.  **
 **  exception.                                                                     **
 **                                                                                 **
 **    *********************** The QuasarSoft Ltd. EXCEPTION ******************     **
 **    * You may not exercise any of the rights granted to You in any manner  *     **
 **    * that is primarily intended for or directed toward commercial         *     **
 **    * advantage or private monetary compensation. The exchange of the      *     **
 **    * Program for other copyrighted works by means of digital file-sharing *     **
 **    * or otherwise shall not be considered to be intended for or directed  *     **
 **    * toward commercial advantage or private monetary compensation,        *     **
 **    * provided there is no payment of any monetary compensation in         *     **
 **    * connection with the exchange of copyrighted works.                   *     **
 **    ************************************************************************     **
 **                                                                                 **
 **  Q-KernelFree is distributed in the hope that it will be useful,  but  WITHOUT  **
 **  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS  ** 
 **  FOR  A  PARTICULAR  PURPOSE.  See the full license text at the following link  ** 
 **  <http://www.quasarsoft.com/license.html>                                       ** 
 **                                                                                 **
 *************************************************************************************/  

#include "qKernel.h"


void qThrSetPriority(pTCB pTcb, uint8_t Prio) {
#ifndef __NO_CHECK__
    unsigned prio=Prio;
    if (qKrnInIsr()) {
        xErrNtf(qERR_THR_ISR);
        return;
    }
    if (pTcb==0 || pTcb->Type!=xTYPE_TCB) {
        xErrNtf(qERR_THR_ID);
        return;
    }
    if (xKrnIsInitDone() && (prio==0 || prio>250)) {
        xErrNtf(qERR_THR_PRIO);
        return;
    }
#endif

    qCrtEnter();
    pTcb->Prio = Prio;
    if (pTcb->ListType==xLIST_READY) {          // if in the ready list
        xRemRdyList(pTcb);                     // remove from ready list
        if (xInsRdyList(pTcb)) {                // and insert with the new priority
            ySwitchThread();                    // Switch thread and EXIT_CRITICAL
            return;                             // if on top of ready list
        }
    }
    qCrtExit();
}



