/*************************************************************************************
 **  Q-KernelFree  Copyright (C) 2013 QuasarSoft Ltd.                               **
 **                                                                                 **
 **  This file is part of Q-KernelFree distribution.                                **
 **  Q-KernelFree is free software:  you can redistribute it and/or modify it under **
 **  the terms of the  GNU  General  Public  License  (version 3) as published  by  **
 **  the Free Software  Foundation ***** AND MODIFIED BY ***** the QuasarSoft Ltd.  **
 **  exception.                                                                     **
 **                                                                                 **
 **    *********************** The QuasarSoft Ltd. EXCEPTION ******************     **
 **    * You may not exercise any of the rights granted to You in any manner  *     **
 **    * that is primarily intended for or directed toward commercial         *     **
 **    * advantage or private monetary compensation. The exchange of the      *     **
 **    * Program for other copyrighted works by means of digital file-sharing *     **
 **    * or otherwise shall not be considered to be intended for or directed  *     **
 **    * toward commercial advantage or private monetary compensation,        *     **
 **    * provided there is no payment of any monetary compensation in         *     **
 **    * connection with the exchange of copyrighted works.                   *     **
 **    ************************************************************************     **
 **                                                                                 **
 **  Q-KernelFree is distributed in the hope that it will be useful,  but  WITHOUT  **
 **  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS  ** 
 **  FOR  A  PARTICULAR  PURPOSE.  See the full license text at the following link  ** 
 **  <http://www.quasarsoft.com/license.html>                                       ** 
 **                                                                                 **
 *************************************************************************************/  

#include "qKernel.h"



pOBJ xObjOpenNB(char* pName, unsigned ErrId, uint8_t Type) {
    pOBJ p;

#ifndef __NO_CHECK__
    if (qKrnInIsr()) {
        xErrNtf(ErrId+2);                       // ISR
        return NULL;
    }
    if (pName==0) {
        xErrNtf(ErrId+8);                       // N0_NAME
        return NULL;
    }
#endif

    qCrtEnter();
    if (Type == xTYPE_TCB)
        p = (pOBJ)xGetTcb(pName);
    else
        p = xObjSearch(pName, Type);            // get the object
    qCrtExit();
    return p;
}


pEVT qEvtOpenNB(char* pName) {
    return (pEVT)xObjOpenNB(pName, qERR_EVT_ID, xTYPE_EVT);
}

pMTX qMtxOpenNB(char* pName) {
    return (pMTX)xObjOpenNB(pName, qERR_MTX_ID, xTYPE_MTX);
}

pPIP qPipOpenNB(char* pName) {
    return (pPIP)xObjOpenNB(pName, qERR_PIP_ID, xTYPE_PIP);
}

pQUE qQueOpenNB(char* pName) {
    return (pQUE)xObjOpenNB(pName, qERR_QUE_ID, xTYPE_QUE);
}

pSEM qSemOpenNB(char* pName) {
    unsigned p =(unsigned)xObjOpenNB(pName, qERR_SEM_ID, xTYPE_SEM);
    p = p + 4*sizeof(int);
    return (pSEM)p;
}

pTCB qThrOpenNB(char* pName) {
    return (pTCB)xObjOpenNB(pName, qERR_THR_ID, xTYPE_TCB);
}

pTMR qTmrOpenNB(char* pName) {
    return (pTMR)xObjOpenNB(pName, qERR_TMR_ID, xTYPE_TMR);
}

pPUB qPubOpenNB(char* pName) {
    return (pPUB)xObjOpenNB(pName, qERR_PUB_ID, xTYPE_PUB);
}

